import 'package:flutter/services.dart';
import 'RewardAC.dart';

class FlutterBaseReward{
  String _channelNm;
  MethodChannel _platform;
  RewardLAC _rewardListener;

  String get channelNm => _channelNm;

  FlutterBaseReward(RewardLAC listener){
    this._channelNm = "com.bidmad.sdk.reward/Flutter";
    this._rewardListener = listener;

    _initChannel(_channelNm, _rewardListener);
  }

  FlutterBaseReward.init(RewardLAC listener, String channelName){
    this._rewardListener = listener;
    this._channelNm = channelName;

    _initChannel(_channelNm, _rewardListener);
  }

  Future<void> _initChannel(String channelNm, RewardLAC listener) async {
    _platform = MethodChannel(channelNm);
    _platform.setMethodCallHandler(_handleMethod);
  }

  Future<void> load() async {
    await _platform.invokeMethod('load');
  }

  Future<void> show() async {
    await _platform.invokeMethod('show');
  }

  Future<void> setUserId(String userId) async {
    await _platform.invokeMethod('setUserId', userId);
  }

  Future<void> setAdInfo(String zoneId) async {
    await _platform.invokeMethod('setAdInfo', zoneId);
  }

  Future<dynamic> _handleMethod(MethodCall call) async {
    print("flutter call.method = " + call.method);

    switch (call.method) {
      case 'onLoadAd':
        _rewardListener.onLoadAd(call.arguments.toString());
        break;
      case 'onShowAd':
        _rewardListener.onShowAd(call.arguments.toString());
        break;
      case 'onFailedAd':
        _rewardListener.onFailedAd(call.arguments.toString());
        break;
      case 'onCompleteAd':
        _rewardListener.onCompleteAd(call.arguments.toString());
        break;
      case 'onOpenAd':
        _rewardListener.onOpenAd(call.arguments.toString());
        break;
      case 'onCloseAd':
        _rewardListener.onCloseAd(call.arguments.toString());
        break;
      case 'onClickAd':
        _rewardListener.onClickAd(call.arguments.toString());
        break;
      case 'onSkippedAd':
        _rewardListener.onSkippedAd(call.arguments.toString());
        break;
      default:
        throw ('method not defined');
    }
  }
}